use strict;
use warnings;
use Data::Dumper;

#my $cmd ="locate -d  locate/locate.db id";
#open IN,"$cmd|";

sub emit
{
    my $n=shift;
#    print "new id=$n->{s}\n";

    return unless $n->{s};

    my $tc=$n->{p}{tree_code};
    die Dumper($n)  unless $tc;
    my $s = $n->{s};
    my $sid=$s;
    $sid=$1 if ($s =~ /id-(\d+)/);

    print "<$tc id=\"$sid\"\n";

    foreach my $p (keys %{$n->{p}})
    {
	my $o=$n->{p}{$p};
	my $oid=$o;
	if ($o =~ /id-(\d+)/)
	{
	    $oid=$1;
	}
	print "\t $p=\"$oid\"\n";
    }

    print "/>\n";

}
my $cur={s=>""};

print q[<?xml version="1.0" encoding="utf-8"?>
<?xml-stylesheet href="/home/mdupont/gcc/introspector/style.xsl"  type="text/xsl"?>
];

print "<nodes>\n";
while (<>)
{
    chomp;

    if (/\/OBJ\/(id-\d+)\/(\w+)\/(.+)/)
    {
	my $s=$1;
	my $p=$2;
	my $o=$3;

	if ($cur->{s} ne $s)
	{
	    emit($cur);
	    $cur={s=>$s};
	}

	if ($p eq "modifier")
	{
#	    warn "$p $o";
	    $p .= "_" . $o;

	}

	while (exists($cur->{p}{$p}))
	{
	    $p .= "_";

	}
	$cur->{p}{$p}=$o;

#	push @{$cur->{stmts}}, [$p,$o];
    }
    else
    {
#	print "<SRC>$_</SRC>\n";
    }

}
emit($cur);
print "</nodes>";

