#include "introspector_stdlib.h"
#include "introspector_gcc.h"
#include "introspector.h"

enum tree_index
{
  TI_ERROR_MARK,
  TI_INTQI_TYPE,
  TI_INTHI_TYPE,
  TI_INTSI_TYPE,
  TI_INTDI_TYPE,
  TI_INTTI_TYPE,

  TI_UINTQI_TYPE,
  TI_UINTHI_TYPE,
  TI_UINTSI_TYPE,
  TI_UINTDI_TYPE,
  TI_UINTTI_TYPE,

  TI_INTEGER_ZERO,
  TI_INTEGER_ONE,
  TI_INTEGER_MINUS_ONE,
  TI_NULL_POINTER,

  TI_SIZE_ZERO,
  TI_SIZE_ONE,

  TI_BITSIZE_ZERO,
  TI_BITSIZE_ONE,
  TI_BITSIZE_UNIT,

  TI_PUBLIC,
  TI_PROTECTED,
  TI_PRIVATE,

  TI_BOOLEAN_FALSE,
  TI_BOOLEAN_TRUE,

  TI_COMPLEX_INTEGER_TYPE,
  TI_COMPLEX_FLOAT_TYPE,
  TI_COMPLEX_DOUBLE_TYPE,
  TI_COMPLEX_LONG_DOUBLE_TYPE,

  TI_FLOAT_TYPE,
  TI_DOUBLE_TYPE,
  TI_LONG_DOUBLE_TYPE,

  TI_FLOAT_PTR_TYPE,
  TI_DOUBLE_PTR_TYPE,
  TI_LONG_DOUBLE_PTR_TYPE,
  TI_INTEGER_PTR_TYPE,

  TI_VOID_TYPE,
  TI_PTR_TYPE,
  TI_CONST_PTR_TYPE,
  TI_SIZE_TYPE,
  TI_PID_TYPE,
  TI_PTRDIFF_TYPE,
  TI_VA_LIST_TYPE,
  TI_BOOLEAN_TYPE,
  TI_FILEPTR_TYPE,
  TI_VOID_LIST_NODE,
  TI_MAIN_IDENTIFIER,
  TI_MAX
};



// __attribute__ ((__noreturn__))
void fancy_abort (const char * a, int b, const char * c)
{
}

tree decl_assembler_name (tree t)
{
    return t;
}

tree bit_position (tree t)
{
    return t;
}

//__attribute__ ((__nonnull__ (1)))
void warning (const char *a, ...) 
{
}

void dump_function_to_file (tree t, FILE * f, int i)
{
    
}

const enum tree_code_class tree_code_type[] = {};
const char *const tree_code_name[]  = {};
tree global_trees[TI_MAX];
const struct lang_hooks lang_hooks;
const char *dump_base_name;
